indexing

	description:
		"Scanner for mime messages."

	standards:
		"Based on RFC 2822, 2045 and 2047."

	known_bugs:
		"1. B encoding not decoded."

	author: "Berend de Boer"
	date: "$Date: $"
	revision: "$Revision: $"


class

	EPX_MIME_SCANNER


inherit

	YY_COMPRESSED_SCANNER_SKELETON
		export
			{EPX_MIME_PARSER} yyEnd_of_file_character
		redefine
			make
		end

	UT_CHARACTER_CODES
		export {NONE} all end

	KL_CHARACTER_ROUTINES
		export
			{NONE} all
		end


creation

	make


feature -- Status report

	valid_start_condition (sc: INTEGER): BOOLEAN is
			-- Is `sc' a valid start condition?
		do
			Result := (INITIAL <= sc and sc <= DATE)
		end

feature {NONE} -- Implementation

	yy_build_tables is
			-- Build scanner tables.
		do
			yy_nxt ?= yy_nxt_template
			yy_chk ?= yy_chk_template
			yy_base ?= yy_base_template
			yy_def ?= yy_def_template
			yy_ec ?= yy_ec_template
			yy_meta ?= yy_meta_template
			yy_accept ?= yy_accept_template
		end

	yy_execute_action (yy_act: INTEGER) is
			-- Execute semantic action.
		do
if yy_act <= 56 then
if yy_act <= 28 then
if yy_act <= 14 then
if yy_act <= 7 then
if yy_act <= 4 then
if yy_act <= 2 then
if yy_act = 1 then
	yy_column := yy_column + yy_end - yy_start - yy_more_len
--|#line 70 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 70")
end
-- Ignore white space
else
	yy_column := yy_column + 3
--|#line 74 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 74")
end

							last_token := mime_tokens.FN_BCC
							to_condition := STRUCTURED_FIELD_BODY
							
end
else
if yy_act = 3 then
	yy_column := yy_column + 19
--|#line 82 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 82")
end

							last_token := mime_tokens.FN_CONTENT_DISPOSITION
							to_condition := MIME_FIELD_BODY
							
else
	yy_column := yy_column + 14
--|#line 86 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 86")
end

							last_token := mime_tokens.FN_CONTENT_LENGTH
							to_condition := MIME_FIELD_BODY
							
end
end
else
if yy_act <= 6 then
if yy_act = 5 then
	yy_column := yy_column + 25
--|#line 90 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 90")
end

							last_token := mime_tokens.FN_CONTENT_TRANSFER_ENCODING
							to_condition := MIME_FIELD_BODY
							
else
	yy_column := yy_column + 12
--|#line 94 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 94")
end

							last_token := mime_tokens.FN_CONTENT_TYPE
							to_condition := MIME_FIELD_BODY
							
end
else
	yy_column := yy_column + 4
--|#line 98 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 98")
end

							last_token := mime_tokens.FN_DATE
							to_condition := STRUCTURED_FIELD_BODY
							
end
end
else
if yy_act <= 11 then
if yy_act <= 9 then
if yy_act = 8 then
	yy_column := yy_column + 17
--|#line 106 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 106")
end

							last_token := mime_tokens.FN_IF_MODIFIED_SINCE
							to_condition := STRUCTURED_FIELD_BODY
							
else
	yy_column := yy_column + 10
--|#line 110 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 110")
end

							last_token := mime_tokens.FN_MESSAGE_ID
							to_condition := STRUCTURED_FIELD_BODY
							
end
else
if yy_act = 10 then
	yy_column := yy_column + 12
--|#line 114 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 114")
end

							last_token := mime_tokens.FN_VERSION
							-- I want to see two integers.
							-- tspecials from RFC 2045 include token, so I
							-- just get an atom if parsed according to that syntax.
							to_condition := STRUCTURED_FIELD_BODY
							
else
	yy_column := yy_column + 11
--|#line 127 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 127")
end

							last_token := mime_tokens.FN_RESENT_FROM
							to_condition := STRUCTURED_FIELD_BODY
							
end
end
else
if yy_act <= 13 then
if yy_act = 12 then
	yy_column := yy_column + 15
--|#line 131 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 131")
end

							last_token := mime_tokens.FN_RESENT_REPLY_TO
							to_condition := STRUCTURED_FIELD_BODY
							
else
	yy_column := yy_column + 13
--|#line 135 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 135")
end

							last_token := mime_tokens.FN_RESENT_SENDER
							to_condition := STRUCTURED_FIELD_BODY
							
end
else
	yy_column := yy_column + 11
--|#line 139 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 139")
end

							last_token := mime_tokens.FN_RETURN_PATH
							to_condition := STRUCTURED_FIELD_BODY
							
end
end
end
else
if yy_act <= 21 then
if yy_act <= 18 then
if yy_act <= 16 then
if yy_act = 15 then
	yy_column := yy_column + 6
--|#line 143 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 143")
end

							last_token := mime_tokens.FN_SENDER
							to_condition := STRUCTURED_FIELD_BODY
							
else
	yy_column := yy_column + 2
--|#line 147 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 147")
end

							last_token := mime_tokens.FN_TO
							to_condition := STRUCTURED_FIELD_BODY
							
end
else
if yy_act = 17 then
	yy_column := yy_column + yy_end - yy_start - yy_more_len
--|#line 159 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 159")
end

							last_token := mime_tokens.FIELD_NAME
							last_value := to_canonical_field_name (text)
							to_condition := UNSTRUCTURED_FIELD_BODY
							
else
	yy_column := yy_column + yy_end - yy_start - yy_more_len
--|#line 165 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 165")
end
 -- include space, so it's already skipped
							create {STRING} last_value.make (64)
							last_token := Colon_code
							if to_condition /= 0 then
								set_start_condition (to_condition)
							end
							
end
end
else
if yy_act <= 20 then
if yy_act = 19 then
	yy_line := yy_line + 1
	yy_column := 1
--|#line 173 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 173")
end

							last_token := mime_tokens.CRLF
							
else
	yy_column := yy_column + 1
--|#line 181 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 181")
end

							set_start_condition (COMMENT)
							
end
else
	yy_column := yy_column + 1
--|#line 184 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 184")
end

							create {STRING}  last_value.make (32)
							set_start_condition (DOMAIN_LITERAL)
							
end
end
else
if yy_act <= 25 then
if yy_act <= 23 then
if yy_act = 22 then
	yy_column := yy_column + 1
--|#line 188 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 188")
end
 --"
							create {STRING} last_value.make (32)
							set_start_condition (QUOTED_STRING)
							
else
	yy_column := yy_column + yy_end - yy_start - yy_more_len
--|#line 192 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 192")
end
-- White space, ignore
end
else
if yy_act = 24 then
yy_set_column (1)
--|#line 193 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 193")
end
-- Folded-line white space, ignore
else
	yy_line := yy_line + 1
	yy_column := 1
--|#line 194 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 194")
end

							set_start_condition (INITIAL)
							to_condition := 0
							last_token := mime_tokens.CRLF
							
end
end
else
if yy_act <= 27 then
if yy_act = 26 then
	yy_column := yy_column + yy_end - yy_start - yy_more_len
--|#line 199 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 199")
end
 --'
							last_token := mime_tokens.MIME_ATOM
							if encoded_word_scanner.is_encoded_word (text) then
								last_value := encoded_word_scanner.decode_word (text)
							else
								last_value := text
							end
							
else
	yy_column := yy_column + 1
--|#line 207 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 207")
end
 -- pass rest of stuff as is, perhaps exclude 8-bit chars??
							last_token := text.item (1).code
							
end
else
	yy_column := yy_column + 1
--|#line 215 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 215")
end

							set_start_condition (COMMENT)
							
end
end
end
end
else
if yy_act <= 42 then
if yy_act <= 35 then
if yy_act <= 32 then
if yy_act <= 30 then
if yy_act = 29 then
	yy_column := yy_column + 1
--|#line 218 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 218")
end

							create {STRING} last_value.make (32)
							set_start_condition (DOMAIN_LITERAL)
							
else
	yy_column := yy_column + 1
--|#line 222 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 222")
end
 --"
							create {STRING} last_value.make (32)
							set_start_condition (QUOTED_STRING)
							
end
else
if yy_act = 31 then
	yy_column := yy_column + yy_end - yy_start - yy_more_len
--|#line 226 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 226")
end
-- White space, ignore
else
yy_set_column (1)
--|#line 227 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 227")
end
-- Folded-line white space, ignore
end
end
else
if yy_act <= 34 then
if yy_act = 33 then
	yy_line := yy_line + 1
	yy_column := 1
--|#line 228 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 228")
end

							set_start_condition (INITIAL)
							to_condition := 0
							last_token := mime_tokens.CRLF
							
else
	yy_column := yy_column + yy_end - yy_start - yy_more_len
--|#line 233 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 233")
end
 --"
							last_token := mime_tokens.MIME_ATOM
							if encoded_word_scanner.is_encoded_word (text) then
								last_value := encoded_word_scanner.decode_word (text)
							else
								last_value := text
							end
							
end
else
	yy_column := yy_column + 1
--|#line 241 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 241")
end
 -- just return every other character
							last_token := text.item (1).code
							
end
end
else
if yy_act <= 39 then
if yy_act <= 37 then
if yy_act = 36 then
	yy_column := yy_column + 1
--|#line 245 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 245")
end
 last_token := Semicolon_code 
else
	yy_column := yy_column + 1
--|#line 246 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 246")
end
 last_token := Equal_code 
end
else
if yy_act = 38 then
	yy_column := yy_column + 1
--|#line 247 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 247")
end

							to_condition := PARAMETER
							set_start_condition (COMMENT)
							
else
	yy_column := yy_column + 1
--|#line 251 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 251")
end
 --"
							create {STRING} last_value.make (32)
							to_condition := PARAMETER
							set_start_condition (QUOTED_STRING)
							
end
end
else
if yy_act <= 41 then
if yy_act = 40 then
	yy_column := yy_column + yy_end - yy_start - yy_more_len
--|#line 256 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 256")
end
-- White space, ignore
else
yy_set_column (1)
--|#line 257 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 257")
end
-- Folded-line white space, ignore
end
else
	yy_line := yy_line + 1
	yy_column := 1
--|#line 258 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 258")
end

							set_start_condition (INITIAL)
							to_condition := 0
							last_token := mime_tokens.CRLF
							
end
end
end
else
if yy_act <= 49 then
if yy_act <= 46 then
if yy_act <= 44 then
if yy_act = 43 then
	yy_column := yy_column + yy_end - yy_start - yy_more_len
--|#line 263 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 263")
end
 --"
							last_value := text
							last_token := mime_tokens.MIME_ATOM
							
else
	yy_column := yy_column + 1
--|#line 267 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 267")
end
 -- ignore all other stuff??
							last_token := text.item (1).code
							
end
else
if yy_act = 45 then
	yy_column := yy_column + 3
--|#line 276 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 276")
end
last_token := mime_tokens.KW_SUN
else
	yy_column := yy_column + 3
--|#line 277 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 277")
end
last_token := mime_tokens.KW_MON
end
end
else
if yy_act <= 48 then
if yy_act = 47 then
	yy_column := yy_column + 3
--|#line 278 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 278")
end
last_token := mime_tokens.KW_TUE
else
	yy_column := yy_column + 3
--|#line 279 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 279")
end
last_token := mime_tokens.KW_WED
end
else
	yy_column := yy_column + 3
--|#line 280 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 280")
end
last_token := mime_tokens.KW_THU
end
end
else
if yy_act <= 53 then
if yy_act <= 51 then
if yy_act = 50 then
	yy_column := yy_column + 3
--|#line 281 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 281")
end
last_token := mime_tokens.KW_FRI
else
	yy_column := yy_column + 3
--|#line 282 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 282")
end
last_token := mime_tokens.KW_SAT
end
else
if yy_act = 52 then
	yy_column := yy_column + 6
--|#line 283 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 283")
end
last_token := mime_tokens.KW_SUN
else
	yy_column := yy_column + 6
--|#line 284 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 284")
end
last_token := mime_tokens.KW_MON
end
end
else
if yy_act <= 55 then
if yy_act = 54 then
	yy_column := yy_column + 7
--|#line 285 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 285")
end
last_token := mime_tokens.KW_TUE
else
	yy_column := yy_column + 9
--|#line 286 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 286")
end
last_token := mime_tokens.KW_WED
end
else
	yy_column := yy_column + 8
--|#line 287 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 287")
end
last_token := mime_tokens.KW_THU
end
end
end
end
end
else
if yy_act <= 84 then
if yy_act <= 70 then
if yy_act <= 63 then
if yy_act <= 60 then
if yy_act <= 58 then
if yy_act = 57 then
	yy_column := yy_column + 6
--|#line 288 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 288")
end
last_token := mime_tokens.KW_FRI
else
	yy_column := yy_column + 8
--|#line 289 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 289")
end
last_token := mime_tokens.KW_SAT
end
else
if yy_act = 59 then
	yy_column := yy_column + 3
--|#line 290 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 290")
end
last_token := mime_tokens.MONTH; set_last_integer (1)
else
	yy_column := yy_column + 3
--|#line 291 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 291")
end
last_token := mime_tokens.MONTH; set_last_integer (2)
end
end
else
if yy_act <= 62 then
if yy_act = 61 then
	yy_column := yy_column + 3
--|#line 292 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 292")
end
last_token := mime_tokens.MONTH; set_last_integer (3)
else
	yy_column := yy_column + 3
--|#line 293 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 293")
end
last_token := mime_tokens.MONTH; set_last_integer (4)
end
else
	yy_column := yy_column + 3
--|#line 294 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 294")
end
last_token := mime_tokens.MONTH; set_last_integer (5)
end
end
else
if yy_act <= 67 then
if yy_act <= 65 then
if yy_act = 64 then
	yy_column := yy_column + 3
--|#line 295 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 295")
end
last_token := mime_tokens.MONTH; set_last_integer (6)
else
	yy_column := yy_column + 3
--|#line 296 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 296")
end
last_token := mime_tokens.MONTH; set_last_integer (7)
end
else
if yy_act = 66 then
	yy_column := yy_column + 3
--|#line 297 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 297")
end
last_token := mime_tokens.MONTH; set_last_integer (8)
else
	yy_column := yy_column + 3
--|#line 298 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 298")
end
last_token := mime_tokens.MONTH; set_last_integer (9)
end
end
else
if yy_act <= 69 then
if yy_act = 68 then
	yy_column := yy_column + 3
--|#line 299 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 299")
end
last_token := mime_tokens.MONTH; set_last_integer (10)
else
	yy_column := yy_column + 3
--|#line 300 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 300")
end
last_token := mime_tokens.MONTH; set_last_integer (11)
end
else
	yy_column := yy_column + 3
--|#line 301 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 301")
end
last_token := mime_tokens.MONTH; set_last_integer (12)
end
end
end
else
if yy_act <= 77 then
if yy_act <= 74 then
if yy_act <= 72 then
if yy_act = 71 then
	yy_column := yy_column + 3
--|#line 302 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 302")
end
last_token := mime_tokens.NUMBER; set_last_integer (0)
else
	yy_column := yy_column + 2
--|#line 303 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 303")
end
last_token := mime_tokens.NUMBER; set_last_integer (0)
end
else
if yy_act = 73 then
	yy_column := yy_column + 3
--|#line 304 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 304")
end
last_token := mime_tokens.NUMBER; set_last_integer (-5)
else
	yy_column := yy_column + 3
--|#line 305 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 305")
end
last_token := mime_tokens.NUMBER; set_last_integer (-4)
end
end
else
if yy_act <= 76 then
if yy_act = 75 then
	yy_column := yy_column + 3
--|#line 306 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 306")
end
last_token := mime_tokens.NUMBER; set_last_integer (-6)
else
	yy_column := yy_column + 3
--|#line 307 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 307")
end
last_token := mime_tokens.NUMBER; set_last_integer (-5)
end
else
	yy_column := yy_column + 3
--|#line 308 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 308")
end
last_token := mime_tokens.NUMBER; set_last_integer (-7)
end
end
else
if yy_act <= 81 then
if yy_act <= 79 then
if yy_act = 78 then
	yy_column := yy_column + 3
--|#line 309 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 309")
end
last_token := mime_tokens.NUMBER; set_last_integer (-6)
else
	yy_column := yy_column + 3
--|#line 310 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 310")
end
last_token := mime_tokens.NUMBER; set_last_integer (-8)
end
else
if yy_act = 80 then
	yy_column := yy_column + 3
--|#line 311 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 311")
end
last_token := mime_tokens.NUMBER; set_last_integer (-7)
else
	yy_column := yy_column + yy_end - yy_start - yy_more_len
--|#line 312 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 312")
end
 -- parse these time zones, but ignore them
						  last_token := mime_tokens.NUMBER; last_value := text; set_last_integer (0)
						  
end
end
else
if yy_act <= 83 then
if yy_act = 82 then
	yy_column := yy_column + yy_end - yy_start - yy_more_len
--|#line 315 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 315")
end
 -- finally, parse the shit spammers spew out like time zone XXXXXXXXXXXX
						  last_token := mime_tokens.NUMBER; last_value := text; set_last_integer (0)
						  
else
	yy_column := yy_column + 1
--|#line 318 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 318")
end
last_token := Comma_code
end
else
	yy_column := yy_column + 1
--|#line 319 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 319")
end
last_token := Colon_code
end
end
end
end
else
if yy_act <= 98 then
if yy_act <= 91 then
if yy_act <= 88 then
if yy_act <= 86 then
if yy_act = 85 then
	yy_column := yy_column + 1
--|#line 320 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 320")
end
last_token := Minus_code
else
	yy_column := yy_column + 1
--|#line 321 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 321")
end

						  last_token := Semicolon_code
						  set_start_condition (STRUCTURED_FIELD_BODY)
						  
end
else
if yy_act = 87 then
	yy_column := yy_column + 1
--|#line 325 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 325")
end
 -- " we use this to recognize some s**t
						  last_token := Double_quote_code
						  
else
	yy_column := yy_column + yy_end - yy_start - yy_more_len
--|#line 328 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 328")
end
-- (Folded-line) white space, ignore
end
end
else
if yy_act <= 90 then
if yy_act = 89 then
yy_set_column (1)
--|#line 329 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 329")
end
-- (Folded-line) white space, ignore
else
	yy_column := yy_column + yy_end - yy_start - yy_more_len
--|#line 330 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 330")
end

						  set_last_integer (text.to_integer)
						  last_token := mime_tokens.NUMBER
						  
end
else
	yy_column := yy_column + 1
--|#line 334 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 334")
end

						  to_condition := DATE
						  set_start_condition (COMMENT)
						  
end
end
else
if yy_act <= 95 then
if yy_act <= 93 then
if yy_act = 92 then
	yy_line := yy_line + 1
	yy_column := 1
--|#line 338 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 338")
end

						  set_start_condition (INITIAL)
						  to_condition := 0
						  last_token := mime_tokens.CRLF
						  
else
	yy_column := yy_column + 2
--|#line 347 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 347")
end
 
end
else
if yy_act = 94 then
	yy_column := yy_column + 2
--|#line 348 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 348")
end
 
else
	yy_column := yy_column + 1
--|#line 349 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 349")
end

							if nested_comment_count = 0 then
								set_start_condition (to_condition)
							else
								nested_comment_count := nested_comment_count - 1
							end
							
end
end
else
if yy_act <= 97 then
if yy_act = 96 then
	yy_column := yy_column + 1
--|#line 356 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 356")
end
 nested_comment_count := nested_comment_count + 1 
else
yy_set_line_column
--|#line 357 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 357")
end
 
end
else
	yy_column := yy_column + 2
--|#line 363 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 363")
end
 last_string.append_character (text.item (2)) 
end
end
end
else
if yy_act <= 105 then
if yy_act <= 102 then
if yy_act <= 100 then
if yy_act = 99 then
	yy_column := yy_column + 1
--|#line 364 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 364")
end

							set_start_condition (to_condition)
							last_token := mime_tokens.DOMAIN_LITERAL
							
else
yy_set_column (1)
--|#line 368 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 368")
end

							last_string.append_character (' ')
							
end
else
if yy_act = 101 then
yy_set_line_column
--|#line 371 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 371")
end
 last_string.append_string (text) 
else
	yy_column := yy_column + 2
--|#line 376 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 376")
end
 last_string.append_character (text.item (2)) 
end
end
else
if yy_act <= 104 then
if yy_act = 103 then
	yy_column := yy_column + 1
--|#line 377 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 377")
end
 --"
							set_start_condition (to_condition)
							last_token := mime_tokens.QUOTED_STRING
							
else
yy_set_column (1)
--|#line 381 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 381")
end

							last_string.append_character (' ')
							
end
else
yy_set_line_column
--|#line 384 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 384")
end
 --"
							last_string.append_string (text)
							
end
end
else
if yy_act <= 109 then
if yy_act <= 107 then
if yy_act = 106 then
	yy_column := yy_column + yy_end - yy_start - yy_more_len
--|#line 391 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 391")
end

							if encoded_word_scanner.is_encoded_word (text) then
								if prev_word_was_encoded then
									from
									until
										last_string.is_empty or else
										(last_string.item (last_string.count) /= ' ' and then
										last_string.item (last_string.count) /= '%T')
									loop
										last_string.keep_head (last_string.count - 1)
									end
								end
								last_string.append_string (encoded_word_scanner.decode_word (text))
								prev_word_was_encoded := True
							else
								last_string.append_string (text)
								prev_word_was_encoded := False
							end
							
else
	yy_column := yy_column + yy_end - yy_start - yy_more_len
--|#line 410 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 410")
end
last_string.append_string (text)
end
else
if yy_act = 108 then
yy_set_column (1)
--|#line 411 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 411")
end
 -- Folded line
							last_string.append_character (' ')
							
else
	yy_line := yy_line + 1
	yy_column := 1
--|#line 414 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 414")
end

							if last_string.is_empty then
								last_token := mime_tokens.CRLF
							else
								less (0)
								last_token := mime_tokens.FIELD_BODY
							end
							to_condition := 0
							set_start_condition (INITIAL)
							prev_word_was_encoded := False
							
end
end
else
if yy_act <= 111 then
if yy_act = 110 then
	yy_column := yy_column + 1
--|#line 425 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 425")
end
-- ignore lone CR's
else
	yy_column := yy_column + 1
--|#line 431 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 431")
end
-- ignore all other charcters, i.e. ascii unprintables and high ascii
end
else
yy_set_line_column
--|#line 0 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 0")
end
last_token := yyError_token
fatal_error ("scanner jammed")
end
end
end
end
end
end
		end

	yy_execute_eof_action (yy_sc: INTEGER) is
			-- Execute EOF semantic action.
		do
			inspect yy_sc
when 0, 1, 2, 3, 4, 5, 6, 7, 8, 9 then
--|#line 0 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 0")
end
 terminate 
			else
				terminate
			end
		end

feature {NONE} -- Table templates

	yy_nxt_template: ANY is
			-- This is supposed to be "like FIXED_INTEGER_ARRAY_TYPE",
			-- but once functions cannot be declared with anchored types.
		once
			Result := yy_fixed_array (<<
			    0,   22,   23,   24,   25,   37,   38,   39,   37,   38,
			   39,   76,   77,  356,   78,   27,   66,   67,   66,   67,
			  138,  139,  140,   28,   29,   30,   70,   71,   76,   77,
			   31,   78,   70,   71,   32,  203,  160,  116,   33,   34,
			   35,  117,  145,  182,  201,  149,  192,  165,  157,   22,
			   22,   23,   24,   25,   79,   68,  155,   68,  157,  166,
			  156,  157,  157,  158,   27,  157,  144,  157,  161,   72,
			   73,   79,   28,   29,   30,   72,   73,  159,  167,   31,
			  172,  163,  162,   32,  211,  157,  157,   33,   34,   35,
			  157,  157,  157,  164,  173,  189,  190,  174,   22,   40,

			   41,   42,   43,  157,   45,   46,   40,  194,   40,  168,
			   40,  175,  169,   40,   40,   40,  181,   40,  157,   40,
			  157,  179,  193,  170,  157,  157,  171,  157,  195,  196,
			  198,  199,  157,  180,  197,  157,  157,  157,  157,  157,
			  157,  154,  200,   47,   40,   40,  355,   40,   40,   41,
			   42,   43,  176,   45,   46,   40,  177,   40,  157,   40,
			  354,  202,   40,   40,   40,  353,   40,  157,   40,  157,
			  204,  178,  205,  206,  208,  209,  210,  217,  157,  207,
			  216,  212,  157,  157,  157,  157,  352,  213,  157,  157,
			  157,  157,   47,   40,   40,  157,   40,   48,   49,   50,

			   51,  218,   53,   54,   48,  220,   48,  219,  157,   48,
			  214,   48,   48,   48,   48,   48,   48,   48,  157,  215,
			  278,  351,  285,  350,  349,  348,  347,  157,  157,  157,
			  286,  279,  280,  298,  346,  345,  344,  287,  343,  299,
			  342,   55,   48,   48,   48,   49,   50,   51,  341,   53,
			   54,   48,  340,   48,  339,  338,   48,  337,   48,   48,
			   48,   48,   48,   48,   48,  128,  336,  335,  334,  333,
			  132,  128,  128,  128,  128,  132,  128,  132,  332,  331,
			  330,  132,  329,  328,  132,  327,  326,  325,   55,   48,
			   48,   56,   57,   58,   59,  324,   61,   62,   56,  323,

			   56,  322,  321,   56,  320,   56,   63,   56,   64,   56,
			   56,   56,  136,  319,  318,  317,  316,  136,  315,  136,
			  314,  313,  312,  136,  311,  310,  136,  309,  308,  307,
			  306,  305,  304,  303,  302,   56,   56,   56,   56,   57,
			   58,   59,  301,   61,   62,   56,  300,   56,  297,  296,
			   56,  295,   56,   63,   56,   64,   56,   56,   56,  294,
			  293,  292,  291,  290,  289,  288,  284,  283,  282,  281,
			  277,  276,  275,  274,  273,  272,  271,  270,  269,  268,
			  267,  266,   56,   56,   56,   74,   80,   81,   82,   74,
			   83,   84,   74,   85,   86,   87,   74,   74,   88,   89,

			   90,   74,   74,   74,   74,   74,   91,   92,   93,   94,
			   95,   96,   97,   92,   92,   98,   92,   92,   99,  100,
			  101,  102,   92,  103,  104,  105,   92,  106,   92,   74,
			   74,   74,  107,   74,   26,   26,   26,   26,   26,   26,
			   26,   26,   26,   26,   26,   26,   26,   26,   26,   26,
			   26,   36,   36,   36,   36,   36,   36,   36,   36,   36,
			   36,   36,   36,   36,   36,   36,   36,   36,   44,   44,
			   44,   44,   44,   44,   44,   44,   44,   44,   44,   44,
			   44,   44,   44,   44,   44,   52,   52,   52,   52,   52,
			   52,   52,   52,   52,   52,   52,   52,   52,   52,   52,

			   52,   52,   60,   60,   60,   60,   60,   60,   60,   60,
			   60,   60,   60,   60,   60,   60,   60,   60,   60,   65,
			   65,   65,   65,   65,   65,   65,   65,   65,   65,   65,
			   65,   65,   65,   65,   65,   65,   69,   69,   69,   69,
			   69,   69,   69,   69,   69,   69,   69,   69,   69,   69,
			   69,   69,   69,   74,   74,   74,   74,   74,   74,   74,
			   74,   74,   74,   74,   74,   74,   74,   74,   74,   74,
			   75,   75,   75,   75,   75,   75,   75,   75,   75,   75,
			   75,   75,   75,   75,   75,   75,   75,  110,  110,  110,
			  110,  110,  110,  110,  110,  110,  110,  110,  110,  110,

			  110,  121,  265,  121,  121,  121,  121,  121,  121,  121,
			  121,  121,  121,  121,  121,  121,  121,  121,  137,  137,
			  137,  137,  264,  263,  137,  137,  137,  137,  137,  137,
			  137,  137,  137,  137,  137,  140,  140,  140,  140,  140,
			  140,  140,  140,  140,  140,  140,  140,  140,  140,  140,
			  262,  140,  143,  143,  143,  143,  143,  143,  143,  143,
			  143,  143,  143,  143,  143,  143,  143,  143,  143,  145,
			  145,  145,  261,  145,  145,  145,  145,  145,  145,  145,
			  145,  145,  145,  145,  145,  145,  148,  148,  148,  148,
			  148,  148,  148,  148,  148,  148,  148,  148,  148,  148,

			  148,  148,  148,  260,  259,  258,  257,  256,  255,  254,
			  253,  252,  251,  250,  249,  248,  247,  246,  245,  244,
			  243,  242,  241,  240,  239,  238,  237,  236,  235,  234,
			  233,  232,  231,  230,  229,  228,  227,  226,  225,  224,
			  223,  222,  221,  157,  157,  153,  151,  151,  150,  146,
			  146,  141,  141,  134,  134,  133,  130,  130,  129,  126,
			  126,  125,  123,  123,  122,  191,  188,  187,  186,  185,
			  184,  183,  111,  108,  157,  153,  153,  153,  152,  151,
			  150,  147,  146,  142,  141,  135,  134,  133,  131,  130,
			  129,  127,  126,  125,  124,  123,  122,  120,  119,  118,

			  115,  114,  113,  112,  111,  109,  108,  356,   21,  356,
			  356,  356,  356,  356,  356,  356,  356,  356,  356,  356,
			  356,  356,  356,  356,  356,  356,  356,  356,  356,  356,
			  356,  356,  356,  356,  356,  356,  356,  356,  356,  356,
			  356,  356,  356,  356,  356,  356,  356,  356,  356,  356,
			  356,  356,  356,  356,  356,  356,  356,  356>>)
		end

	yy_chk_template: ANY is
			-- This is supposed to be "like FIXED_INTEGER_ARRAY_TYPE",
			-- but once functions cannot be declared with anchored types.
		once
			Result := yy_fixed_array (<<
			    0,    1,    1,    1,    1,    3,    3,    3,    4,    4,
			    4,   17,   17,    0,   17,    1,   11,   11,   12,   12,
			   68,   68,   72,    1,    1,    1,   13,   13,   18,   18,
			    1,   18,   14,   14,    1,  166,   94,   32,    1,    1,
			    1,   32,   79,  106,  164,   79,  378,   97,  166,    1,
			    2,    2,    2,    2,   17,   11,   91,   12,   94,   98,
			   91,   97,  164,   93,    2,  106,   72,   91,   95,   13,
			   13,   18,    2,    2,    2,   14,   14,   93,   98,    2,
			  100,   96,   95,    2,  172,   98,   93,    2,    2,    2,
			  172,   95,  100,   96,  101,  118,  118,  102,    2,    5,

			    5,    5,    5,   96,    5,    5,    5,  156,    5,   99,
			    5,  102,   99,    5,    5,    5,  105,    5,  101,    5,
			  102,  104,  155,   99,  105,  377,   99,  156,  158,  159,
			  161,  162,  155,  104,  160,   99,  158,  159,  161,  162,
			  104,  376,  163,    5,    5,    5,  354,    5,    6,    6,
			    6,    6,  103,    6,    6,    6,  103,    6,  160,    6,
			  353,  165,    6,    6,    6,  352,    6,  163,    6,  165,
			  167,  103,  167,  168,  169,  170,  171,  178,  103,  168,
			  177,  173,  169,  168,  171,  167,  351,  174,  170,  173,
			  178,  177,    6,    6,    6,  174,    6,    7,    7,    7,

			    7,  179,    7,    7,    7,  182,    7,  180,  179,    7,
			  175,    7,    7,    7,    7,    7,    7,    7,  175,  176,
			  268,  350,  274,  349,  347,  346,  344,  176,  182,  180,
			  274,  268,  268,  287,  343,  342,  341,  274,  340,  287,
			  338,    7,    7,    7,    8,    8,    8,    8,  337,    8,
			    8,    8,  336,    8,  335,  334,    8,  333,    8,    8,
			    8,    8,    8,    8,    8,  368,  331,  329,  328,  327,
			  369,  368,  368,  368,  368,  369,  368,  369,  326,  325,
			  324,  369,  323,  321,  369,  319,  318,  317,    8,    8,
			    8,    9,    9,    9,    9,  315,    9,    9,    9,  314,

			    9,  312,  311,    9,  310,    9,    9,    9,    9,    9,
			    9,    9,  370,  309,  308,  307,  306,  370,  305,  370,
			  304,  303,  302,  370,  300,  299,  370,  298,  297,  296,
			  294,  293,  292,  291,  290,    9,    9,    9,   10,   10,
			   10,   10,  289,   10,   10,   10,  288,   10,  286,  285,
			   10,  284,   10,   10,   10,   10,   10,   10,   10,  281,
			  280,  279,  278,  277,  276,  275,  273,  271,  270,  269,
			  267,  266,  265,  264,  263,  262,  261,  259,  255,  254,
			  253,  252,   10,   10,   10,   19,   19,   19,   19,   19,
			   19,   19,   19,   19,   19,   19,   19,   19,   19,   19,

			   19,   19,   19,   19,   19,   19,   19,   19,   19,   19,
			   19,   19,   19,   19,   19,   19,   19,   19,   19,   19,
			   19,   19,   19,   19,   19,   19,   19,   19,   19,   19,
			   19,   19,   19,   19,  357,  357,  357,  357,  357,  357,
			  357,  357,  357,  357,  357,  357,  357,  357,  357,  357,
			  357,  358,  358,  358,  358,  358,  358,  358,  358,  358,
			  358,  358,  358,  358,  358,  358,  358,  358,  359,  359,
			  359,  359,  359,  359,  359,  359,  359,  359,  359,  359,
			  359,  359,  359,  359,  359,  360,  360,  360,  360,  360,
			  360,  360,  360,  360,  360,  360,  360,  360,  360,  360,

			  360,  360,  361,  361,  361,  361,  361,  361,  361,  361,
			  361,  361,  361,  361,  361,  361,  361,  361,  361,  362,
			  362,  362,  362,  362,  362,  362,  362,  362,  362,  362,
			  362,  362,  362,  362,  362,  362,  363,  363,  363,  363,
			  363,  363,  363,  363,  363,  363,  363,  363,  363,  363,
			  363,  363,  363,  364,  364,  364,  364,  364,  364,  364,
			  364,  364,  364,  364,  364,  364,  364,  364,  364,  364,
			  365,  365,  365,  365,  365,  365,  365,  365,  365,  365,
			  365,  365,  365,  365,  365,  365,  365,  366,  366,  366,
			  366,  366,  366,  366,  366,  366,  366,  366,  366,  366,

			  366,  367,  251,  367,  367,  367,  367,  367,  367,  367,
			  367,  367,  367,  367,  367,  367,  367,  367,  371,  371,
			  371,  371,  250,  249,  371,  371,  371,  371,  371,  371,
			  371,  371,  371,  371,  371,  372,  372,  372,  372,  372,
			  372,  372,  372,  372,  372,  372,  372,  372,  372,  372,
			  248,  372,  373,  373,  373,  373,  373,  373,  373,  373,
			  373,  373,  373,  373,  373,  373,  373,  373,  373,  374,
			  374,  374,  247,  374,  374,  374,  374,  374,  374,  374,
			  374,  374,  374,  374,  374,  374,  375,  375,  375,  375,
			  375,  375,  375,  375,  375,  375,  375,  375,  375,  375,

			  375,  375,  375,  246,  245,  244,  243,  242,  241,  240,
			  239,  238,  237,  236,  235,  234,  233,  232,  231,  230,
			  229,  228,  227,  226,  225,  224,  223,  221,  220,  219,
			  218,  217,  215,  209,  201,  191,  190,  189,  188,  187,
			  186,  185,  184,  181,  154,  153,  152,  151,  150,  147,
			  146,  142,  141,  135,  134,  133,  131,  130,  129,  127,
			  126,  125,  124,  123,  122,  119,  117,  116,  115,  114,
			  113,  112,  111,  108,   92,   88,   87,   85,   82,   81,
			   80,   77,   76,   71,   70,   59,   58,   57,   51,   50,
			   49,   43,   42,   41,   39,   38,   37,   35,   34,   33,

			   31,   30,   29,   28,   27,   25,   23,   21,  356,  356,
			  356,  356,  356,  356,  356,  356,  356,  356,  356,  356,
			  356,  356,  356,  356,  356,  356,  356,  356,  356,  356,
			  356,  356,  356,  356,  356,  356,  356,  356,  356,  356,
			  356,  356,  356,  356,  356,  356,  356,  356,  356,  356,
			  356,  356,  356,  356,  356,  356,  356,  356>>)
		end

	yy_base_template: ANY is
			-- This is supposed to be "like FIXED_INTEGER_ARRAY_TYPE",
			-- but once functions cannot be declared with anchored types.
		once
			Result := yy_fixed_array (<<
			    0,    0,   49,    3,    6,   98,  147,  196,  243,  290,
			  337,    9,   11,   23,   29,    0,    0,    8,   25,  384,
			    0,  807,  808,  804,  808,  802,    0,  802,  779,  766,
			  779,  773,   11,  773,  772,  761,    0,  794,  793,  791,
			  808,  791,  790,  788,    0,  808,  808,  808,  808,  788,
			  787,  785,    0,  808,  808,  808,  808,  785,  784,  782,
			    0,  808,  808,  808,  808,    0,  808,  808,   13,    0,
			  782,  780,   19,  808,  808,    0,  780,  778,  808,   39,
			  778,  777,  775,  808,  808,  763,  808,  762,  761,  808,
			  808,   19,  726,   38,   10,   43,   55,   13,   37,   87,

			   44,   70,   72,  130,   92,   76,   17,    0,  771,  808,
			    0,  770,  747,  735,  729,  757,  728,  732,   56,  730,
			    0,    0,  762,  761,  760,  759,  758,  757,    0,  756,
			  755,  754,    0,  753,  752,  751,    0,    0,  808,  808,
			    0,  750,  749,    0,  808,    0,  748,  747,    0,  808,
			  746,  745,  744,  731,  696,   84,   79,    0,   88,   89,
			  110,   90,   91,  119,   14,  121,    0,  137,  135,  134,
			  140,  136,   42,  141,  147,  170,  179,  143,  142,  160,
			  181,  695,  180,    0,  702,  715,  706,  700,  712,  711,
			  695,  710,    0,    0,    0,    0,    0,    0,    0,    0,

			    0,  709,    0,    0,    0,    0,    0,    0,    0,  708,
			    0,    0,    0,    0,    0,  691,    0,  706,  692,  690,
			  693,  701,    0,  690,  703,  713,  688,  684,  695,  698,
			  697,  680,  695,  677,  690,  688,  678,  687,  683,  668,
			  669,  673,  669,  662,  661,  679,  659,  647,  628,  584,
			  582,  572,  355,  354,  368,  367,    0,    0,    0,  355,
			    0,  354,  331,  349,  362,  345,  360,  332,  193,  332,
			  324,  323,    0,  344,  197,  335,  334,  324,  324,  335,
			  334,  337,    0,    0,  307,  319,  322,  195,  320,  317,
			  304,  297,  295,  296,  290,    0,  290,  293,  305,  288,

			  299,    0,  286,  287,  287,  293,  287,  278,  286,  278,
			  278,  291,  266,    0,  255,  269,    0,  251,  246,  246,
			    0,  244,    0,  271,  242,  240,  249,  242,  238,  227,
			    0,  236,    0,  231,  220,  218,  212,  210,  216,    0,
			  208,  225,  209,  198,  200,    0,  190,  189,    0,  199,
			  185,  161,  135,  125,  118,    0,  808,  433,  450,  467,
			  484,  501,  518,  535,  552,  569,  584,  600,  262,  267,
			  309,  617,  634,  651,  668,  685,  127,  111,   32>>)
		end

	yy_def_template: ANY is
			-- This is supposed to be "like FIXED_INTEGER_ARRAY_TYPE",
			-- but once functions cannot be declared with anchored types.
		once
			Result := yy_fixed_array (<<
			    0,  357,  357,  358,  358,  359,  359,  360,  360,  361,
			  361,  362,  362,  363,  363,  364,  364,  365,  365,  356,
			   19,  356,  356,  356,  356,  356,  366,  356,  366,  366,
			  366,  366,  366,  366,  366,  366,  367,  356,  356,  356,
			  356,  356,  356,  356,  368,  356,  356,  356,  356,  356,
			  356,  356,  369,  356,  356,  356,  356,  356,  356,  356,
			  370,  356,  356,  356,  356,  371,  356,  356,  371,  372,
			  372,  372,  373,  356,  356,  374,  374,  374,  356,  375,
			  356,  356,  356,  356,  356,  356,  356,  356,  356,  356,
			  356,  376,  376,  376,  376,  376,  376,  376,  376,  376,

			  376,  376,  376,  376,  376,  376,  376,  377,  356,  356,
			  366,  356,  366,  366,  366,  366,  366,  366,  366,  366,
			  366,  367,  356,  356,  356,  356,  356,  356,  368,  356,
			  356,  356,  369,  356,  356,  356,  370,  371,  356,  356,
			  372,  372,  372,  372,  356,  374,  374,  374,  374,  356,
			  356,  356,  356,  356,  378,  378,  378,  377,  378,  378,
			  378,  378,  378,  378,  378,  378,  378,  378,  378,  378,
			  378,  378,  378,  378,  378,  378,  378,  378,  378,  378,
			  378,  378,  378,  366,  366,  366,  366,  366,  366,  366,
			  366,  366,  377,  377,  377,  377,  377,  377,  377,  377,

			  377,  377,  377,  377,  377,  377,  377,  377,  377,  377,
			  377,  377,  377,  377,  377,  377,  377,  377,  377,  377,
			  377,  366,  366,  366,  366,  366,  366,  366,  366,  377,
			  377,  377,  377,  377,  377,  377,  366,  366,  366,  366,
			  366,  366,  366,  377,  377,  377,  377,  377,  377,  377,
			  366,  366,  366,  366,  366,  366,  366,  377,  377,  377,
			  377,  377,  377,  377,  366,  366,  366,  366,  366,  366,
			  377,  377,  377,  377,  366,  366,  366,  366,  366,  366,
			  366,  366,  377,  377,  377,  366,  366,  366,  366,  366,
			  366,  366,  366,  366,  366,  377,  366,  366,  366,  366,

			  366,  366,  366,  366,  366,  366,  366,  366,  366,  366,
			  366,  366,  366,  366,  366,  366,  366,  366,  366,  366,
			  366,  366,  366,  366,  366,  366,  366,  366,  366,  366,
			  366,  366,  366,  366,  366,  366,  366,  366,  366,  366,
			  366,  366,  366,  366,  366,  366,  366,  366,  366,  366,
			  366,  366,  366,  366,  366,  366,    0,  356,  356,  356,
			  356,  356,  356,  356,  356,  356,  356,  356,  356,  356,
			  356,  356,  356,  356,  356,  356,  356,  356,  356>>)
		end

	yy_ec_template: ANY is
			-- This is supposed to be "like FIXED_INTEGER_ARRAY_TYPE",
			-- but once functions cannot be declared with anchored types.
		once
			Result := yy_fixed_array (<<
			    0,    1,    1,    1,    1,    1,    1,    1,    1,    2,
			    3,    1,    1,    4,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    2,    5,    6,    5,    5,    5,    5,    5,
			    7,    8,    5,    9,   10,   11,   12,   13,   14,   14,
			   14,   14,   14,   14,   14,   14,   14,   14,   15,   16,
			   17,   18,   19,   20,   21,   22,   23,   24,   25,   26,
			   27,   28,   29,   30,   31,   32,   33,   34,   35,   36,
			   37,   32,   38,   39,   40,   41,   42,   43,   32,   44,
			   32,   45,   46,   47,    5,   48,    5,   22,   23,   24,

			   25,   26,   27,   28,   29,   30,   31,   32,   33,   34,
			   35,   36,   37,   32,   38,   39,   40,   41,   42,   43,
			   32,   44,   32,    5,    5,    5,    5,   49,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,

			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1>>)
		end

	yy_meta_template: ANY is
			-- This is supposed to be "like FIXED_INTEGER_ARRAY_TYPE",
			-- but once functions cannot be declared with anchored types.
		once
			Result := yy_fixed_array (<<
			    0,    1,    2,    2,    2,    3,    4,    5,    6,    3,
			    7,    3,    8,    9,   10,    1,    7,    7,   11,    7,
			   12,   13,   14,   14,   14,   14,   14,   14,   14,   14,
			   14,   14,   14,   14,   14,   14,   14,   14,   14,   14,
			   14,   14,   14,   14,   14,    7,   15,   16,   14,   17>>)
		end

	yy_accept_template: ANY is
			-- This is supposed to be "like FIXED_INTEGER_ARRAY_TYPE",
			-- but once functions cannot be declared with anchored types.
		once
			Result := yy_fixed_array (<<
			    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
			    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
			    0,  113,  111,    1,   19,  111,   17,   18,   17,   17,
			   17,   17,   17,   17,   17,   17,  106,  107,  109,  110,
			   27,   23,   25,   27,   26,   22,   20,   21,   35,   31,
			   33,   35,   34,   30,   28,   29,   44,   40,   42,   44,
			   43,   39,   38,   36,   37,   97,   96,   95,   97,  101,
			  101,  101,  101,   99,  112,  105,  105,  105,  103,  105,
			   88,   92,  112,   87,   91,  112,   83,   85,   90,   84,
			   86,   81,   81,   81,   81,   81,   81,   81,   81,   81,

			   81,   81,   81,   81,   81,   81,   81,   82,    1,   19,
			   17,   18,   17,   17,   17,   17,   17,   17,   17,   17,
			   16,  106,  107,  108,  109,   23,   24,   25,   26,   31,
			   32,   33,   34,   40,   41,   42,   43,   97,   93,   94,
			  101,  100,  101,   98,   98,  105,  104,  105,  102,  102,
			   88,   89,   92,   90,   81,   81,   81,   82,   81,   81,
			   81,   81,   81,   81,   81,   81,   81,   81,   81,   81,
			   81,   81,   81,   81,   81,   81,   81,   81,   81,   81,
			   81,   72,   81,    2,   17,   17,   17,   17,   17,   17,
			   17,   17,   81,   62,   66,   76,   75,   70,   74,   73,

			   60,   50,   71,   59,   65,   64,   61,   63,   78,   46,
			   77,   69,   68,   80,   79,   51,   67,   45,   49,   47,
			   48,   17,    7,   17,   17,   17,   17,   17,   17,   82,
			   82,   82,   82,   82,   82,   82,   17,   17,   17,   17,
			   17,   17,   17,   82,   82,   82,   82,   82,   82,   82,
			   17,   17,   17,   17,   17,   17,   15,   57,   53,   82,
			   52,   82,   82,   82,   17,   17,   17,   17,   17,   17,
			   82,   82,   54,   82,   17,   17,   17,   17,   17,   17,
			   17,   17,   58,   56,   82,   17,   17,   17,   17,   17,
			   17,   17,   17,   17,   17,   55,   17,   17,   17,   17,

			   17,    9,   17,   17,   17,   17,   17,   17,   17,   17,
			   17,   17,   17,   11,   17,   17,   14,   17,   17,   17,
			    6,   17,   10,   17,   17,   17,   17,   17,   17,   17,
			   13,   17,    4,   17,   17,   17,   17,   17,   17,   12,
			   17,   17,   17,   17,   17,    8,   17,   17,    3,   17,
			   17,   17,   17,   17,   17,    5,    0>>)
		end

feature {NONE} -- Constants

	yyJam_base: INTEGER is 808
			-- Position in `yy_nxt'/`yy_chk' tables
			-- where default jam table starts

	yyJam_state: INTEGER is 356
			-- State id corresponding to jam state

	yyTemplate_mark: INTEGER is 357
			-- Mark between normal states and templates

	yyNull_equiv_class: INTEGER is 1
			-- Equivalence code for NULL character

	yyReject_used: BOOLEAN is false
			-- Is `reject' called?

	yyVariable_trail_context: BOOLEAN is false
			-- Is there a regular expression with
			-- both leading and trailing parts having
			-- variable length?

	yyReject_or_variable_trail_context: BOOLEAN is false
			-- Is `reject' called or is there a
			-- regular expression with both leading
			-- and trailing parts having variable length?

	yyNb_rules: INTEGER is 112
			-- Number of rules

	yyEnd_of_buffer: INTEGER is 113
			-- End of buffer rule code

	yyLine_used: BOOLEAN is true
			-- Are line and column numbers used?

	yyPosition_used: BOOLEAN is false
			-- Is `position' used?

	INITIAL: INTEGER is 0
	UNSTRUCTURED_FIELD_BODY: INTEGER is 1
	STRUCTURED_FIELD_BODY: INTEGER is 2
	MIME_FIELD_BODY: INTEGER is 3
	PARAMETER: INTEGER is 4
	COMMENT: INTEGER is 5
	DOMAIN_LITERAL: INTEGER is 6
	NEXT_WORD: INTEGER is 7
	QUOTED_STRING: INTEGER is 8
	DATE: INTEGER is 9
			-- Start condition codes

feature -- User-defined features



feature {NONE} -- Initialization

	make is
		do
			precursor
			create last_integer
			create encoded_word_scanner.make
		end


feature -- Last returned data

	last_value: ANY


feature -- Input

	new_mime_request_buffer (a_stream: EPX_CHARACTER_INPUT_STREAM): EPX_MIME_BUFFER is
			-- New input buffer for `a_stream'.
		require
			stream_not_void: a_stream /= Void
			stream_open: a_stream.is_open_read
		do
			create Result.make (a_stream)
		ensure
			new_buffer_not_void: Result /= Void
		end


feature -- Condition setting

	expect_date is
		do
			set_start_condition (DATE)
		end

	reset_start_condition is
			-- Used in error recovery to return to start condition.
		do
			set_start_condition (INITIAL)
		end

	start_parameter is
		do
			to_condition := PARAMETER
			set_start_condition (PARAMETER)
		end


feature {NONE} -- Mime specific tokens

	mime_tokens: expanded EPX_MIME_TOKENS


feature {NONE} -- State during parsing

	call_enable_keyword_after_space: BOOLEAN
			-- Flag to call `enable_keyword_after_space' when encountered an ATOM.

	expect_keyword: BOOLEAN
			-- Treat certain atoms specially.

	expect_keyword_after_space: BOOLEAN
			-- Treat certain atoms specially after a space, crlf in
			-- folded-line or comment has been ecountered.

	to_condition: INTEGER
			-- Used by ':' to switch to correct field body parser.

	nested_comment_count: INTEGER
			-- Keep track of nested comments.

-- 	is_keyword (a_word: STRING): BOOLEAN is
-- 			-- True if `a_word' is in `keywords'.
-- 		local
-- 			upper_word: STRING
-- 		do
-- 			upper_word := clone (a_word)
-- 			upper_word.to_upper
-- 			keywords.search (upper_word)
-- 			Result := keywords.found
-- 		end

-- 	keywords: DS_HASH_TABLE [INTEGER, STRING] is
-- 			-- List of atoms that can be treated as a keyword.
-- 		once
-- 			create Result.make (64)
-- 			keywords.put (mime_tokens.KW_BY, "BY")
-- 			keywords.put (mime_tokens.KW_FOR, "FOR")
-- 			keywords.put (mime_tokens.KW_FROM, "FROM")
-- 			keywords.put (mime_tokens.KW_ID, "ID")
-- 			keywords.put (mime_tokens.KW_MULTIPART, "MULTIPART")
-- 			keywords.put (mime_tokens.KW_VIA, "VIA")
-- 			keywords.put (mime_tokens.KW_WITH, "WITH")
-- 		ensure
-- 			result_not_void: Result /= Void
-- 		end

	last_integer: INTEGER_REF

	last_string: STRING is
		do
			Result ?= last_value
		ensure
			last_string_returned: Result /= Void
		end

-- 	last_keyword: INTEGER is
-- 			-- Last keyword if `is_keyword' returned True.
-- 		do
-- 			Result := keywords.found_item
-- 		end

	set_last_integer (value: INTEGER) is
			-- Set `last_integer' and make sure `last_value' is this integer.
		do
			create last_integer
			last_integer.set_item (value)
			last_value := last_integer
		ensure
			new_integer: last_integer /= old last_integer
			value_set: last_integer.item = value
			last_value_is_integer: last_value = last_integer
		end

	prev_word_was_encoded: BOOLEAN
			-- Used to skip white space between encoded-words in an
			-- unstructured field.


feature {NONE} -- Implementation

	to_canonical_field_name (a_field_name: STRING): STRING is
			-- Turn `a_field_name' into a canonical field name. A
			-- canonical field name as the first character in uppercase
			-- and every character after a '-' as well. All other
			-- characters are lower case.
		require
			a_field_name_not_empty: a_field_name /= Void and then not a_field_name.is_empty
		local
			c,
			prev_c: CHARACTER
			i: INTEGER
		do
			create Result.make_from_string (a_field_name)
			prev_c := Result.item (1)
			Result.put (as_upper (prev_c), 1)
			from
				i := 2
			until
				i > Result.count
			loop
				c := Result.item (i)
				if prev_c = '-' then
					Result.put (as_upper (c), i)
				else
					Result.put (as_lower (c), i)
				end
				prev_c := c
				i := i + 1
			end
		end


feature {NONE} -- RFC 2047 encoded stuff handling

	encoded_word_scanner: EPX_MIME_ENCODED_WORD_SCANNER


invariant

	last_integer_not_void: last_integer /= Void
	never_a_keyword_in_start_condition:
		start_condition = INITIAL implies
			(not expect_keyword and not expect_keyword_after_space)
	encoded_word_scanner_not_void: encoded_word_scanner /= Void

end
